/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.assignJan25;

import java.util.Random;

import com.sunlabs.archsim.gasp.Branch;
import com.sunlabs.archsim.gasp.BranchAction;


/**
 * Branch - two outputs, directs an output to them in a random fashion.
 * @author ib27688
 *
 */
public class RandomBranch extends Branch {
	
	public RandomBranch(String name) {
		super(name, 2, new RandomBranchAction(2));
	}
 
} // RandomBranch

class RandomBranchAction extends BranchAction {
	static final String name= "RandomBranchAction";
	
	Random rnd;
	
	public RandomBranchAction(int numIn) {
		super(name, numIn);
		rnd= new Random();
	}
	
	
	public int selectBranch(Object data) {
		return rnd.nextInt(numBranches);
	}
} // ToggleAction
