package com.sunlabs.archsim.fleet.common;

/**
 *
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 * 
 * A wrapper for data objects.
 * The "valid" field indicates whether this data is valid.
 * Objects of this class are to be produced at the output of ships.
 * 
 * @author ib27688
 *
 */

public class Data implements Cloneable {
	
	/** the data */
	public Object value;
	
	/** Is the data valid? True = yes, false= no */ 
	public boolean valid;
	
	public Data() {
		value= null;
		valid= true;
	}
	
	public Data(boolean v) {
		value= null;
		valid= v;
	}
	
	public Data(Object v) {
		value= v;
		valid= true;
	}
	
	public Data(Object d, boolean v) {
		value= d;
		valid= v;
	}
	
	public String toString() {
		return "Data: value = " + value + ", validity= " + valid;
	}
	
	/** Compare to another data object */
	public boolean equals(Object d) {
		boolean equal= true;
		if (d instanceof Data) {
			Data cmp= (Data)d;
			equal= ((cmp.value == null && value== null) || cmp.value.equals(value)) && (cmp.valid == valid); 
		}
		else {
			equal= false;
		}
		return equal;
	} // equals
	
	public Object clone() {
		Data d= new Data();
		d.valid= valid;
		d.value= value;
		return d;
	}
	
} // class Data
